/////////////////////////////////////////////////////////////////////////////
// XPath Class  version 3.0  20060531 by Mark Alan Gable
// (C) 2006 Mark Alan Gable  All Rights Reserved. No part of this code can be copied, 
// sold or redistributed commercially without prior authorization from the author.
//
// revsions:
// 20060531  rewrote code to be actual class
//////////////////////////////////////////////////////////////////////////////

class XPath {
	public var XMLDoc:XML;
	private var debug:Boolean;
	private var DOMPath:Object;
	private var found:Boolean; 
	private var nodeList:Array; 
	private var Xpath:Array;
	private var XpathTestArray:Array;
	private static var counter:Number;
	private var lastXpathExpr:Array;
	
	function XPath(xmlDoc:String, debug:Boolean){
		XMLDoc = setXMLDoc(xmlDoc); //XML document to search 
		lastXpathExpr = new Array();
		counter = 0;
		this.debug = (debug == false || debug == undefined) ? false: true;
	}

	//
	function buildDOMPath(whichNode:Object,w:Number):Void{
		if(debug)trace("found step!!!");
		DOMPath = whichNode;
		if(isXpathComplete(w)){
			if(debug)trace("FOUND! " + DOMPath);
			found = true;
		}
	}
	//
	function incrementDocumentNode(whichNode:Object):Void{
		var node = (typeof whichNode == "object") ? whichNode.nodeName : whichNode;
		nodeList.push(node);
		if (debug){trace("+ currentPosition: " + nodeList.toString());}
	}
	//
	function deincrementDocumentNode():Void{
		nodeList.pop();
		if (debug){trace("- currentPosition: " + nodeList.toString());}
	}
	//
	function searchDOM(whichNodeSet:Object):Object{
		if(!found){
			for (var x = 0; x < whichNodeSet.childNodes.length; x++){
				var node = whichNodeSet.childNodes[x];
				var foundStep = false;
				if(isElement(node)){
					var lastDocNodeFound = nodeList.length;
					foundStep = XpathTestArray[lastDocNodeFound].nodeTest(node,XpathTestArray[lastDocNodeFound]);
					if (foundStep){
						buildDOMPath(node,1);
						if (peek("testType","A")){
							found = XpathTestArray[lastDocNodeFound+1].nodeTest(node,XpathTestArray[lastDocNodeFound+1]);
							if (found) {
								buildDOMPath(getAttributeFromDocNode(node,XpathTestArray[lastDocNodeFound+1].attribute),2);
								return DOMPath; // moved to inside this.found test on 20040518
							}
						}
					}
					incrementDocumentNode(node);
				}else{
					incrementDocumentNode("#text")
				}
				if (foundStep && node.hasChildNodes()){
					searchDOM(node);
					if (found){return DOMPath;}
					if (isElement(node)){deincrementDocumentNode();}
				}else{
					if (found){return DOMPath;}  //added 20040516
					deincrementDocumentNode();
				}
			}
			if (!found || !foundStep) {DOMPath = null;return null;} //added 20040516
		}
	}
	
	//
	function selectSingleNode(expr:String):Object{
		var XpathExpr = (expr.charAt(0) == "/") ? expr.substr(1): expr;
		found = false;
		nodeList = new Array();
		Xpath = XpathExpr.split("/");
		if(debug){ trace("The XPath is " + Xpath);}
		XpathTestArray = new Array();
		if(debug) trace("=============== building XPath tests ============================");
		for (var i = 0; i< Xpath.length; i++){
			XpathTestArray.push(parseXPathNode(Xpath[i]));
			if (debug)printObj (XpathTestArray[i]);
		}
		if(debug) trace("=============== starting search ============================");
		if (areXPathConsecutive(lastXpathExpr, Xpath)) { //added 20040602
			lastXpathExpr = Xpath;
			DOMPath = DOMPath.nextSibling; 
			return DOMPath;
		} 
		lastXpathExpr = Xpath;  //added 20040602
		return (searchDOM(XMLDoc));
	}
	
	//
	function getText(XpathExpr:String):Object{
		var results = selectSingleNode(XpathExpr)
		return (typeof results == "object") ? results.firstChild.nodeValue : results;
	}
	
	//
	function printObj(whichObj:Object):Void{
		trace("TEST "+ ++counter +": ");
		var prop:String;
		var p:String;
		for (prop in whichObj){
			trace(prop + ": " + whichObj[prop]);
			if (typeof whichObj[prop] == "object"){
				for(p in whichObj[prop]){
					trace("\t" + p + ": " + whichObj[prop][p]);
				}
			}
		}
	}
	
	//
	function peek(whichAttribute:String, whichValue:String):Boolean{ // check to see if next test in XPath node is an attribute test
		return (XpathTestArray[nodeList.length+1][whichAttribute] == whichValue ) ? true : false;
	} 
	
	//
	function isXpathComplete(w:Number):Boolean{ // check to see if all node test in XPath have been completed. w argument is for attribute test 
		return (nodeList.length + w == Xpath.length) ? true : false;
	}
	
	function setXMLDoc(whichXMLdoc:String):XML{ //set search document
	 	return new XML(whichXMLdoc);
	}  
	
	//
	function parseXPathNode(XpathNode:String):Object{
		if (hasPredicate(XpathNode)){ //node has predicate test
			var ps = getPredicateString(XpathNode);
			if (contains(ps,"@") && contains(ps,"=")){ // node is attribute value test
				return XpathNodeObj ("Epavt", Epavt,getElementFromPredicate(XpathNode),null,predicateAttributeValue(ps)); //"pavt";
			}else if (ps.charAt(0)=="@"){ //node is predicate attribute test
				return  XpathNodeObj ("Epat",Epat,getElementFromPredicate(XpathNode),null,predicateAttribute(ps)); //"pat";
			}else if (! isNaN(ps)){ //node is predicate position test
				return  XpathNodeObj ("ppt",predicatePositionTest,getElementFromPredicate(XpathNode),null,predicatePosition(ps)); //"ppt";
			}else{	// is error
				return "ERROR";
			}
		}else{
			if (isNaN(XpathNode.charAt(0))){
				if(XpathNode.charAt(0)=="@"){
					return XpathNodeObj ("A",attributeTest,null,getAttributeFromXPath(XpathNode),null);  //"A"; // node is attribute test
				}else if (XpathNode.charAt(0)=="*"){
					return XpathNodeObj ("*", wildCardMatch,null,null,null); // wildcard test added 20040520
				}else{
					return XpathNodeObj("E",elementTest,XpathNode,null,null); //"E"; // node is element test
				}
			}else{
				return "ERROR";
			}
		}
	}
	
	function XpathNodeObj(tt:String,xpnt:Function,xpe:String,xpa:String,xppstr:Object):Object {
		//this.testType = tt;
		//this.nodeTest = xpnt;
		//this.element = xpe;
		//this.attribute = xpa;
		//this.predicate = xppstr;
		return {testType:tt,nodeTest:xpnt,element:xpe,attribute:xpa,predicate:xppstr};
	}
	
	//predicate Objects
	function predicateAttributeValue(ps:String):Object{
		var xattribute = getAttributeFromPredicateAttributeTest(ps)
		var xvalue = getValueFromPredicateAttributeTest(ps)
		return {pAttribute:xattribute,pValue:xvalue};
	}
	
	//
	function predicateAttribute(ps:String):Object{
		//this.pAttribute = getAttributeFromPredicate(ps);
		var xattribute = getAttributeFromPredicate(ps);
		return {pAttribute:xattribute};
	}
	
	//
	function predicatePosition(ps:String):Object{
		//this.pSearchPosition = ps;
		//this.pCurrentPosition = 1;
		return {pSearchPosition:ps,pCurrentPosition:1};
	}
	
	//////////////////////////
	//predicate tests
	//////////////////////////
	static function Epavt(docNode:Object,XpathNode:Object):Boolean{
		return (elementTest(docNode,XpathNode) && predicateAttributeValueTest(docNode,XpathNode)) ? true : false;
	}
	//
	static function Epat(docNode:Object,XpathNodeObj:Object):Boolean{
		return (elementTest(docNode,XpathNodeObj) && predicateAttributeTest(docNode,XpathNodeObj)) ? true : false;
	}
	//
	static function predicateAttributeTest(docNode:Object,XPathNodeObj:Object):Boolean{
		var attribute = XPathNodeObj.predicate.pAttribute;
		return (docNode.attributes[attribute].length > 0) ? true : false;
	}
	//
	static function predicateAttributeValueTest(docNode:Object,XpathNode:Object):Boolean{
		var attribute = XpathNode.predicate.pAttribute;
		var value = XpathNode.predicate.pValue;
		return (docNode.attributes[attribute] == value) ? true : false;
	}
	//
	function predicatePositionTest(docNode:Object,XpathNode:Object):Boolean{
		var XpathPosition = XpathNode.predicate.pSearchPosition;
		var currentPosition = (elementTest(docNode,XpathNode))? XpathNode.predicate.pCurrentPosition++ : 0;
		return  (XpathPosition == currentPosition) ? true : false;
	}
			
	///////////////////////////////////////
	//element and attribute tests
	///////////////////////////////////////
	static function elementTest(docNode,XpathNodeObj):Boolean{
		var xpathNode = XpathNodeObj.element;
		return (docNode.nodeName == xpathNode) ? true : false;
	}
	//
	static function attributeTest(docNode,XpathNodeObj):Boolean{
		var attribute = XpathNodeObj.attribute;
		return (docNode.attributes[attribute].length > 0) ? true : false;
	}
	static function wildCardMatch():Boolean{ // wildcard test added 20040520
		return true;
	}
	//
	//////////////////////////////
	//parse functions
	//////////////////////////////
	static function hasPredicate(XpathNode:String):Boolean { 
		return (contains(XpathNode,"[") && contains(XpathNode, "]"))? true : false;
	}
	//
	static function getElementFromPredicate(XpathNode:String):String{
		return XpathNode.substr(0,XpathNode.indexOf("["));
	}
	//
	static function getAttributeFromXPath(XpathNode:String):String{ 
		return (XpathNode.substr(1));
	}
	//
	static function getAttributeFromDocNode(docNode,attribute):String{ // string (DOM node object,string)
		return (docNode.attributes[attribute]);
	}
	//
	static function getPredicateString(XpathNode:String):String{
		return XpathNode.substring(XpathNode.indexOf("[")+1, XpathNode.indexOf("]"));
	}
	
	static function getAttributeFromPredicate(XpathNode){ // string (string)
		return XpathNode.substring(XpathNode.indexOf("@")+1);
	}
	
	static function getAttributeFromPredicateAttributeTest(predicate:String):String{
		return predicate.substring(predicate.indexOf("@")+1,predicate.indexOf("="));
	}
	
	static function getValueFromPredicateAttributeTest(predicate:String):String{
		return predicate.substring(predicate.indexOf("'")+1,predicate.lastIndexOf("'"));
	}
	
	static function isXpathAnAttributeSearch(xpathexpr:String):Boolean{
		return (xpathexpr.substr(xpathexpr.lastIndexOf("/")+ 1,1) == "@") ? true : false;
	}
	
	static function getAttributeFromXpathexpr(xpathexpr:String):String{
		return (xpathexpr.substring(xpathexpr.lastIndexOf("/")+ 2));
	}
	
	static function contains(ss:String, sv:String):Boolean{
		return(ss.indexOf(sv) !=-1) ? true : false;
	}
	
	static function isElement(whichNode:XML):Boolean{ // boolean (DOM node object);
		return (whichNode.nodeType == 1) ? true : false;	
	}
	
	static function areXPathConsecutive(expr1:Array,expr2:Array):Boolean{ // added 20040602
		if (expr1 == undefined) return false;
		if (expr1.length != expr2.length) return false;
		for (var i = 0; i < expr1.length; i++){
			if ((contains(expr1[i],"[") && !contains(expr2[i],"[")) || (!contains(expr1[i],"[") && contains(expr2[i],"[")) || (!contains(expr1[i],"[") && !contains(expr2[i],"["))) return false;  //modified 20040607
			var expression1 = (contains(expr1[i],"[")) ? expr1[i].substr(0,expr1[i].indexOf("[")) : expr1[i];
			var expression2 = (contains(expr2[i],"[")) ? expr2[i].substr(0,expr2[i].indexOf("[")) : expr2[i];
			if (expression1 != expression2) return false;
			if (hasPredicate(expr1[i]) && hasPredicate(expr2[i])){
				if ((parseInt(getPredicateString(expr1[i]))+ 1) != parseInt(getPredicateString(expr2[i]))) return false;
			}
		}
		return true;
	}
}